import numpy as np
import pdb
import json
import fnmatch


# A fiddly little helper function to assist loading in json data from the experiments
# In essence, it distinguishes between data we load that need to be converted from lists to arrays
# Items which give a shape return of () fail the try: branch, forcing them to run the except: branch
# Items that give a shape return of (i, ...) pass the try: and hence execute the else: branch
def isarr(var):
	try:
		np.shape(var)[0]
	except:
		res = False
	else:
		res = True
	return res



# Save an experiment dict into JSON format
def saveexpt(filename,expt):
	with open(filename,'w') as ofile: ofile.write(json.dumps(expt))



# Load an experiment from JSON format into a dict
def loadexpt(filename):

	with open(filename,'r') as ifile: jsondat = json.loads(ifile.read())
	expt = {}
	for key in [*jsondat]: 
		if isarr(jsondat[key]):
			expt[key]=np.asarray(jsondat[key])
		else:
			expt[key]=jsondat[key]

	return expt


# List contents of file in a somewhat helpful fashion
def exptinfo(cb):
	
	dimnum = fnmatch.filter(list(cb), 'd?')
	dimstr = fnmatch.filter(list(cb), 'd?k')
	dimvals = fnmatch.filter(list(cb), 'd?v')
	lasthead = dimnum[0]
	cblist = list(cb)

	ii = 0
	while cblist[ii] != lasthead: 
		print(cblist[ii],'=',cb[cblist[ii]])
		ii = ii+1
	
	for ii in np.arange(0,len(dimnum)): print(dimnum[ii],cb[dimstr[ii]],': ',cb[dimvals[ii]])

	return
